---------------
-- Totem Icon Widget
---------------

local path = "Interface\\Addons\\TidyPlates_Threat\\Widgets\\TotemIconWidget\\"

local _, ns = ...
local t = ns.TidyPlates_Threat

local function enabled()
	local db = TidyPlatesThreat.db.profile.totemWidget
	return db.ON
end

local function GetTotemInfo(name)
	local totem = t.Totems[name]
	local db = TidyPlatesThreat.db.profile.totemSettings
	if totem then
		local texture =  path..db[totem][7].."\\"..totem
		return db[totem][3],texture
	else
		return false, nil
	end
end

local function UpdateSettings(frame)
	local db = TidyPlatesThreat.db.profile.totemWidget
	frame:SetHeight(db.scale)
	frame:SetWidth(db.scale)
	frame:SetFrameLevel(frame:GetParent():GetFrameLevel()+1)
	frame:SetPoint(db.anchor,frame:GetParent(),db.x, db.y)
	frame:Show()
end

local function UpdateTotemIconWidget(frame, unit)
	local isActive, texture = GetTotemInfo(unit.name)
	if isActive then
		frame.Icon:SetTexture(texture)
		UpdateSettings(frame)
	else
		frame:Hide()
	end
end

local function CreateTotemIconWidget(parent)
	local frame = CreateFrame("Frame", nil, parent)
	frame:SetWidth(64)
	frame:SetHeight(64)
	frame.Icon = frame:CreateTexture(nil, "OVERLAY")
	frame.Icon:SetPoint("CENTER",frame)
	frame.Icon:SetAllPoints(frame)
	frame:Hide()
	frame.Update = UpdateTotemIconWidget
	return frame
end

ThreatPlatesWidgets.RegisterWidget("TotemIconWidget",CreateTotemIconWidget,false,enabled)